/*
MapMarkers Minecraft Bukkit plugin for showing Essentials warps
and warp events on maps generated by Minecraft Overviewer.
Copyright (C) 2011 Brendan Johan Lee 
Email: brendan (at) vanntett.net

Part of this code is from the Essentials bukkit plug-in
Copyright (C) 2011 Essentials Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
MA  02110-1301, USA.
*/

package is.brendan.WarpMarkers;

import com.earth2me.essentials.IEssentials;
import com.earth2me.essentials.User;
import com.earth2me.essentials.signs.*;
import com.earth2me.essentials.signs.EssentialsSign.*;

import org.bukkit.block.Sign;
import org.bukkit.block.Block;

public class BlockSign implements ISign {
    private final transient Sign sign;
    private final transient Block block;

    public BlockSign(final Block block) {
	this.block = block;
	this.sign = (Sign)block.getState();
    }

    public final String getLine(final int index) {
	return sign.getLine(index);
    }

    public final void setLine(final int index, final String text) {
	sign.setLine(index, text);
    }

    public final Block getBlock() {
	return block;
    }

    public final void updateSign() {
	sign.update();
    }
}